//--- With the help of James Clifford and Eric Nantel ---
//--- Control for Jonny Poole - InnerbreedFX Animatronics ---

#include <Servo.h> 
#include "ServoMovements.h"

//--- Value for the Blinking of LED ---
const int ledPin =  13;
int ledState = LOW;
long previousMillis_LED = 0;  
long interval_LED = 50;

Servo Head_Rotate; 
Servo Head_UpDown; 
Servo Head_LeftRight; 
Servo Neck_UpDown; 
Servo Neck_LeftRight; 
Servo Wing_Right; 
Servo Wing_Left; 
Servo Wings; 

int Head_Rotate_Pos = 90;
int Head_UpDown_Pos = 90;
int Head_LeftRight_Pos = 90;
int Neck_LeftRight_Pos = 90;
int Neck_UpDown_Pos = 90;
int Wing_Right_Pos = 90;
int Wing_Left_Pos = 90;
int Wings_Pos = 90;

unsigned long lastServoMillis_1 = 0;
unsigned long lastServoMillis_2 = 0;

int ServoDelay_1 = 10;
int ServoDelay_2 = 20;

int Head_Rotate_posDirection = 1;
int Head_UpDown_posDirection = 1;
int Head_LeftRight_posDirection = 1;
int Neck_UpDown_posDirection = 1;
int Neck_LeftRight_posDirection = 1;
int Wing_Right_posDirection = 1;
int Wing_Left_posDirection = 1;
int Wings_posDirection = 1;

//Servo ServoPin3;

void setup() { 
  
  Head_Rotate.attach(9);        //Pin-9 on DiaLFonZo-Copter Shield
  Head_UpDown.attach(3);        //Pin-3 on DiaLFonZo-Copter Shield
  Head_LeftRight.attach(10);    //Pin-10 on DiaLFonZo-Copter Shield
  Neck_UpDown.attach(11);       //Pin-11 on DiaLFonZo-Copter Shield
  Neck_LeftRight.attach(8);     //Pin-A0 on DiaLFonZo-Copter Shield
  Wing_Right.attach(7);         //Pin-A1 on DiaLFonZo-Copter Shield
  Wing_Left.attach(6);          //Pin-A2 on DiaLFonZo-Copter Shield
  Wings.attach(5);              //Pin-A3 on DiaLFonZo-Copter Shield
  
  pinMode(ledPin, OUTPUT);
  
  PowerInit(); 
  
  delay(2000);
} 

//--- Main Loop ---
void loop(){

HeadRotate();
HeadUpDown();
Blink_LED();

}

//--- Turn 160deg all the time ---
void HeadRotate(){

    unsigned long currentMillis_1 = millis();

    if (currentMillis_1 - lastServoMillis_1 >= ServoDelay_1) {
        Head_Rotate.write(Head_Rotate_Pos);
        lastServoMillis_1 = currentMillis_1;
        Head_Rotate_Pos += Head_Rotate_posDirection;
        
        if (Head_Rotate_Pos == 170 || Head_Rotate_Pos == 10) {
            Head_Rotate_posDirection = -Head_Rotate_posDirection;
        }  
    }

}

//--- Turn 160deg all the time ---
void HeadUpDown(){

    unsigned long currentMillis_2 = millis();

    if (currentMillis_2 - lastServoMillis_2 >= ServoDelay_2) {
        Head_UpDown.write(Head_UpDown_Pos);
        lastServoMillis_2 = currentMillis_2;
        Head_UpDown_Pos += Head_UpDown_posDirection;
        
        if (Head_UpDown_Pos == 170 || Head_UpDown_Pos == 10) {
            Head_UpDown_posDirection = -Head_UpDown_posDirection;
        }
    }

}

void Blink_LED(){
  
    unsigned long currentMillis_LED = millis();
    if(currentMillis_LED - previousMillis_LED > interval_LED) {
      previousMillis_LED = currentMillis_LED;  
    if (ledState == LOW)
      ledState = HIGH;
    else
      ledState = LOW;
    digitalWrite(ledPin, ledState);
  }
}

//--- Initialisation ---
void PowerInit(){

  Head_Rotate.write(90);        
  Head_UpDown.write(90);        
  Head_LeftRight.write(90);  
  Neck_UpDown.write(90);     
  Neck_LeftRight.write(90);    
  Wing_Right.write(90);  
  Wing_Left.write(90);  
  Wings.write(90);
  delay(500);
  Head_Rotate.write(10);        
  Head_UpDown.write(10);        
  Head_LeftRight.write(10);  
  Neck_UpDown.write(10);     
  Neck_LeftRight.write(10);    
  Wing_Right.write(10);  
  Wing_Left.write(10);  
  Wings.write(10);  
  delay(500);
  Head_Rotate.write(90);        
  Head_UpDown.write(90);        
  Head_LeftRight.write(90);  
  Neck_UpDown.write(90);     
  Neck_LeftRight.write(90);    
  Wing_Right.write(90);  
  Wing_Left.write(90);  
  Wings.write(90);
  delay(500);
  Head_Rotate.write(170);        
  Head_UpDown.write(170);        
  Head_LeftRight.write(170);  
  Neck_UpDown.write(170);     
  Neck_LeftRight.write(170);    
  Wing_Right.write(170);  
  Wing_Left.write(170);  
  Wings.write(170);
  delay(500);
  Head_Rotate.write(90);        
  Head_UpDown.write(90);        
  Head_LeftRight.write(90);  
  Neck_UpDown.write(90);     
  Neck_LeftRight.write(90);    
  Wing_Right.write(90);  
  Wing_Left.write(90);  
  Wings.write(90);
}
